//------------------------------------------------------------
//  This file includes all the objects needed by the editor   |
//  to display the informations on the boards. Also includes  |
//  the method used to save the informations changed by the   |
//  user.                                                     |
//------------------------------------------------------------

//-----------------------------------------------
// Modify boards and interfaces methods
//-----------------------------------------------
var saveBoard = function(formButton){
  var form = formButton.ownerCt.getForm();
  var el = form.getEl();

  el.dom.action = 'config/saveBoards';
  el.dom.method = 'POST';
  var boardInfo = formButton.ownerCt.getItemsValueAsJson();
  form.submit({
    params:{
      'boardInfo': boardInfo
    },
    success: function(){
      reloadTree(true);
    },
    failure: Paraxip.failureMessage
  });

};

var saveInterface = function(formButton){
  var form = formButton.ownerCt.getForm();
  var el = form.getEl();

  el.dom.action = 'config/saveInterfaces';
  el.dom.method = 'POST';

  // getItemsValueAsJson is a Ext.Container override
  var interfaceInfo = formButton.ownerCt.getItemsValueAsJson();
  form.submit({
    params:{
      'interfaceInfo': interfaceInfo
    },
    success: function(){
      reloadTree(true);
    },
    failure: Paraxip.failureMessage
  });

};

var boardCancelFunc = function(){
  reloadTree(true);
};

var formCancel = function (form){
  form.scope.hide();
};

//-----------------------------------------------
// Add/Delete Interfaces methods
//-----------------------------------------------
var addInterfaceHandler = function(){
  alert("Feature not yet supported!");
//  addInterfaceWindow.show(gridInterfacesAnalog);
};

var deleteInterfaceHandler = function(){
  var selectedRecord = gridInterfacesAnalog.getSelectionModel().getSelected();

  if (selectedRecord !== undefined) {
    //submit information
//    Ext.Ajax.request({
//      url: 'config/deleteInterfaceFromEditor',
//      method: 'POST',
//      disableCaching: false,
//      params: {"selectedInterface":Ext.util.JSON.encode(selectedRecord.json)},
//      success: function(){
//        reloadTree(true);
//      },
//      failure: Paraxip.failureMessage
//    });
    alert("Feature not yet supported!");
  }
};

var saveInterfaceForm = function(){
  //submit information
  var form = addInterfaceForm.getForm();
  var el = form.getEl();

  el.dom.action = 'config/addInterfaceFromEditor';
  el.dom.method = 'POST';
  var newInterfaceData = addInterfaceForm.getItemsValueAsJson();
  form.submit({
    params:{
      'newInterfaceData'  : newInterfaceData
    },
    success: function(){
      reloadTree(true);
    },
    failure: Paraxip.failureMessage
  });

  addInterfaceWindow.hide();
};

//-----------------------------------------------
// Add/Delete Boards methods
//-----------------------------------------------
var addBoardHandler = function(){
 alert("Feature not yet supported!");
//  addBoardWindow.show(gridBoards);
};

var deleteBoardHandler = function(){
  var selectedRecord = gridBoards.getSelectionModel().getSelected();

  if (selectedRecord !== undefined) {
    //submit information
//    Ext.Ajax.request({
//      url: 'config/deleteBoardFromEditor',
//      method: 'POST',
//      disableCaching: false,
//      params: {"selectedBoard":Ext.util.JSON.encode(selectedRecord.json)},
//      success: function(){
//        reloadTree(false);
//      },
//      failure: Paraxip.failureMessage
//    });
    alert("Feature not yet supported!");
  }
};

var saveBoardForm = function(){
  //submit information
  var form = addBoardForm.getForm();
  var el = form.getEl();

  el.dom.action = 'config/addBoardFromEditor';
  el.dom.method = 'POST';
  var newBoardData = addBoardForm.getItemsValueAsJson();
  form.submit({
    params:{
      'newBoardData'  : newBoardData
    },
    success: function(){
      reloadTree(true);
    },
    failure: Paraxip.failureMessage
  });

  addBoardWindow.hide();
};

//-----------------------------------------------
// Intefaces Grids
//-----------------------------------------------
var gridInterfacesDigital = new Ext.grid.GridPanel({
  title         : 'Interfaces Grid',
  id          : 'gridInterfacesDigital',
  autoScroll  : true,
  layout      : 'fit',
  store       : new Ext.data.JsonStore({
    id: 'gridInterfacesDigital',
    url: 'config/getGridDigitalInterfacesData',
    root: 'data',
    //,autoLoad: true
    fields: [
      {name: 'id'},
      {name: 'displayName'},
      {name: 'wanpipe'},
      {name: 'nodeId'} //Not displayed
    ]
  }),
  columns    :[
    {header: "ID", width: 35, sortable: true, dataIndex: 'id', css:'padding:5px;'},
    {header: "Name", width: 200, sortable: true, dataIndex: 'displayName', css:'padding:5px;'},
    {header: "Wanpipe", width: 100, sortable: true, dataIndex: 'wanpipe', css:'padding:5px;'}
  ],
  viewConfig :{forceFit:true}
}); // eo apply

gridInterfacesDigital.on('rowdblclick', function(grid, rowIndex){
  var record = grid.store.getAt(rowIndex);
  goToNode(record.get('nodeId'));
});

var gridInterfacesAnalog = new Ext.grid.GridPanel({
  title         : 'Interfaces Grid',
  id          : 'gridInterfacesAnalog',
  autoScroll  : true,
  layout      : 'fit',
  store       : new Ext.data.JsonStore({
    id: 'gridInterfacesAnalog',
    url: 'config/getGridAnalogInterfacesData',
    root: 'data',
    //,autoLoad: true
    fields: [
      {name: 'id'},
      {name: 'displayName'},
      {name: 'wanpipeInterface'},
      {name: 'nodeId'} //Not displayed
    ]
  }),
  columns    :[
    {header: "ID", width: 35, sortable: true, dataIndex: 'id', css:'padding:5px;'},
    {header: "Name", width: 200, sortable: true, dataIndex: 'displayName', css:'padding:5px;'},
    {header: "WanpipeInterface", width: 100, sortable: true, dataIndex: 'wanpipeInterface', css:'padding:5px;'}
  ],
  viewConfig :{forceFit:true}
}); // eo apply

//TODO - Uncomment when Add/Delete Interface functionnalities will be implemented
//gridInterfacesAnalog.addButton("Add",addInterfaceHandler,gridInterfacesAnalog);
//gridInterfacesAnalog.addButton("Delete",deleteInterfaceHandler,gridInterfacesAnalog);

gridInterfacesAnalog.on('rowdblclick', function(grid, rowIndex){
  var record = grid.store.getAt(rowIndex);
  goToNode(record.get('nodeId'));
});

var addInterfaceForm = new Ext.form.FormPanel({
  id        : "add_interface_form",
  region    : "center",
  bodyStyle : 'padding:10px;',
  items     : [{
    xtype:"textfield",
    id:"newIntefaceName",
    fieldLabel:"Interface Name"
  }]
});

var addInterfaceWindow = new Ext.Window({
  title       : 'Add Interface',
  layout      : 'border',
  width       : 505,
  height      : 300,
  closeAction : 'hide',
  plain       : true,
  id          : "add_interface_window"
});

addInterfaceWindow.add( addInterfaceForm );
addInterfaceForm.addButton("Add", saveInterfaceForm, gridInterfacesAnalog);
addInterfaceForm.addButton("Cancel", formCancel, addInterfaceWindow);

var frmDigitalBoard = new Ext.FormPanel({
  id          : 'frmDigitalBoard',
  title       : 'Boards Details',
  labelWidth  : 75, // label settings here cascade unless overridden
  layout      : 'form',
  frame       : true,
  bodyStyle   : 'padding:5px 5px 0',
  width       : 350,
  labelPad    : 20,
  autoScroll  : true,
  layoutConfig: {
    labelSeparator: ''
  },
  defaults    : {
    width: 230,
    msgTarget: 'side'
  },
  defaultType : 'textfield',
  items       : [{
    name: 'nodeId',
    hidden: true,
    hideLabel: true
  },{
    fieldLabel: 'ID',
    name: 'id',
    helpText : "sangomaBoardCommonAttributesID",
    disabled: true
  },{
    fieldLabel: 'Name',
    name: 'displayName',
    helpText : "sangomaBoardCommonAttributesdisplayName"
  },{
    fieldLabel: 'Type',
    name: 'type',
    disabled: true
  },{
    fieldLabel: 'Model',
    name: 'model',
    disabled: true
  },{
    fieldLabel: 'Number of Interfaces',
    name: 'numInterfaces',
    disabled: true
  }],
  buttons     : [{
    text: 'Save',
    handler: saveBoard
  },{
    text: 'Cancel',
    handler: boardCancelFunc
  }]
});

var panelDigitalBoard = new Ext.Panel({
  id           : 'panelDigitalBoard',
  region       : 'center',
  layout       : 'accordion',
  border       : false,
  closable     : false,
  buttonAlign  : 'right'
});

panelDigitalBoard.add(frmDigitalBoard);
panelDigitalBoard.add(gridInterfacesDigital);

var frmAnalogBoard = new Ext.FormPanel({
  id          : 'frmAnalogBoard',
  title       : 'Boards Details',
  labelWidth  : 75, // label settings here cascade unless overridden
  layout      : 'form',
  frame       : true,
  bodyStyle   : 'padding:5px 5px 0',
  width       : 350,
  labelPad    : 20,
  autoScroll  : true,
  layoutConfig: {
    labelSeparator: ''
  },
  defaults    : {
    width: 230,
    msgTarget: 'side'
  },
  defaultType : 'textfield',
  items       : [{
    name: 'nodeId',
    hidden: true,
    hideLabel: true
  },{
    fieldLabel: 'ID',
    name: 'id',
    disabled: true
  },{
    fieldLabel: 'Name',
    name: 'displayName'
  },{
    fieldLabel: 'Type',
    name: 'type',
    disabled: true
  },{
    fieldLabel: 'Model',
    name: 'model',
    disabled: true
  },{
    fieldLabel: 'Number of Interface',
    name: 'numInterfaces',
    disabled: true
  },{
    xtype: 'numberfield',
    fieldLabel: 'Wanpipe Number',
    name: 'wanpipe'
  }],
  buttons     : [{
    text: 'Save',
    handler: saveBoard
  },{
    text: 'Cancel',
    handler: boardCancelFunc
  }]
});

var panelAnalogBoard = new Ext.Panel({
  id           : 'panelAnalogBoard',
  region       : 'center',
  layout       : 'accordion',
  border       : false,
  closable     : false,
  buttonAlign  : 'right'
});

panelAnalogBoard.add(frmAnalogBoard);
panelAnalogBoard.add(gridInterfacesAnalog);

// create the Grid
var gridBoards = new Ext.grid.GridPanel({
  id    : "gridBoards",
  layout      : 'fit',
  store :  new Ext.data.JsonStore({
   id: 'storeBoards',
   url: 'config/getGridBoardsData',
   root: 'data',
   fields: [
     {name: 'id'},
     {name: 'displayName'},
     {name: 'type'},
     {name: 'model'},
     {name: 'numInterfaces'},
     {name: 'nodeId'} //Not displayed
   ]
  }),
  columns: [
    {header: "ID", width: 35, sortable: true, dataIndex: 'id', css:'padding-top:5px;padding-bottom:5px;'},
    {id:'displayName',header: "Name", width: 100, sortable: true, dataIndex: 'displayName', css:'padding-top:5px;padding-bottom:5px;'},
    {header: "Type", width: 100, sortable: true, dataIndex: 'type', css:'padding-top:5px;padding-bottom:5px;'},
    {header: "Model", width: 100, sortable: true, dataIndex: 'model', css:'padding-top:5px;padding-bottom:5px;'},
    {header: "Number of Interfaces", width: 125, sortable: true, dataIndex:'numInterfaces', css:'padding-top:5px;padding-bottom:5px;'}
  ],
  autoHeight: true,
  stripeRows: true,
  autoExpandColumn: 'displayName',
  title:'Boards Grid',
  viewConfig:{forcefit:true}
});

gridBoards.on('rowdblclick', function(grid, rowIndex){
  var record = grid.store.getAt(rowIndex);
  goToNode(record.get('nodeId'));
});

//Add the buttons to the footer of the grid
// Add and delete button are not ready. The difficulty is in the delete since
// it requires removal of assigned interfaces in the various pannel (physical
// config, isdn config, etc.)
//gridBoards.addButton("Add",addBoardHandler,gridBoards);
//gridBoards.addButton("Delete",deleteBoardHandler,gridBoards);

var interfacesNumber = new Ext.form.ComboBox({
  id              : 'interfacesNumber',
  fieldLabel      : "Number of Interfaces",
  helpText        : "sangomaAnalogInterfacesinterfacewanpipeInterface",
  store           : [[4,'4'],[8,'8'],[12,'12']],
  forceSelection  : true,
  triggerAction   : 'all',
  mode            : 'local',
  typeAhead       : true,
  value           : 4,
  selectOnFocus   : true,
  width           : 100
});

var showInterfacesNumber = function() {
  var selection = boardSelection.getValue();
  if (isBoardAnalog(selection)) {
    interfacesNumber.show(); //show combobox
    interfacesNumber.getEl().up('.x-form-item').setDisplayed(true); //show label
  } else {
    interfacesNumber.hide(); //hide combobox
    interfacesNumber.getEl().up('.x-form-item').setDisplayed(false); //hide label
  }
};

//Selection items
var boardSelection = new Ext.form.ComboBox({
  id              : 'boardSelection',
  fieldLabel      : "Board Type",
  store           : ['A200','A101','A102','A104','A108'],
  forceSelection  : true,
  triggerAction   : 'all',
  mode            : 'local',
  typeAhead       : true,
  value           : "A200",
  selectOnFocus   : true,
  width           : 100
});

boardSelection.on('select', showInterfacesNumber.createDelegate(boardSelection));

var addBoardForm = new Ext.form.FormPanel({
  id        : "add_board_form",
  region    : "center",
  bodyStyle : 'padding:10px;',
  items     : [
    boardSelection,
    interfacesNumber
  ]
});

var addBoardWindow = new Ext.Window({
  title       : 'Add Board',
  layout      : 'border',
  width       : 505,
  height      : 300,
  closeAction : 'hide',
  plain       : true,
  id          : "add_board_window"
});

addBoardWindow.add( addBoardForm );
addBoardForm.addButton("Add", saveBoardForm, gridBoards);
addBoardForm.addButton("Cancel", formCancel, addBoardWindow);

var frmDigitalInterface = new Ext.FormPanel({
  id          : 'frmDigitalInterface',
  title       : 'Interface Details',
  labelWidth  : 75, // label settings here cascade unless overridden
  frame       : true,
  bodyStyle   : 'padding:5px 5px 0',
  width       : 350,
  autoScroll  : true,
  labelPad    : 20,
  layout      : 'form',
  layoutConfig: {
    labelSeparator: ''
  },
  defaults    : {
    width: 230,
    msgTarget: 'side'
  },
  defaultType : 'textfield',

  items       : [{
    name: 'nodeId',
    hidden: true,
    hideLabel: true
  },{
    fieldLabel: 'ID',
    name: 'id',
    helpText: "sangomaInterfaceCommonAttributesID",
    disabled: true
  },{
    fieldLabel: 'Name',
    name: 'displayName',
    helpText: "sangomaInterfaceCommonAttributesdisplayName"
  },{
    fieldLabel: 'Wanpipe',
    name: 'wanpipe',
    helpText: "sangomaDigitalInterfacesinterfacewanpipe",
    disabled: true
  }],

  buttons     : [{
    text: 'Save',
    handler: saveInterface
  },{
    text: 'Cancel',
    handler: boardCancelFunc
  }]
});

var frmAnalogInterface = new Ext.FormPanel({
  id          : 'frmAnalogInterface',
  title       : 'Interface Details',
  labelWidth  : 75, // label settings here cascade unless overridden
  frame       : true,
  bodyStyle   : 'padding:5px 5px 0',
  width       : 350,
  autoScroll  : true,
  labelPad    : 20,
  layout      : 'form',
  layoutConfig: {
    labelSeparator: ''
  },
  defaults    : {
    width: 230,
    msgTarget: 'side'
  },
  defaultType : 'textfield',

  items       : [{
    name: 'nodeId',
    hidden: true,
    hideLabel: true
  },{
    fieldLabel: 'ID',
    name: 'id',
    helpText : "sangomaInterfaceCommonAttributesID",
    disabled: true
  },{
    fieldLabel: 'Name',
    name: 'displayName',
    helpText : "sangomaInterfaceCommonAttributesdisplayName"
  },{
    fieldLabel: 'Wanpipe Interface',
    name: 'wanpipeInterface',
    helpText:"sangomaAnalogInterfacesinterfacewanpipeInterface"
  }],

  buttons     : [{
    text: 'Save',
    handler: saveInterface
  },{
    text: 'Cancel',
    handler: boardCancelFunc
  }]
});

var frmVirtualDigitalBoard = new Ext.FormPanel({
  id          : 'frmVirtualDigitalBoard',
  title       : 'Boards Details',
  labelWidth  : 75, // label settings here cascade unless overridden
  frame       : true,
  bodyStyle   : 'padding:5px 5px 0',
  width       : 350,
  labelPad    : 20,
  autoScroll  : true,
  layout      : 'form',
  layoutConfig: {
    labelSeparator: ''
  },
  defaults    : {
    width: 230,
    msgTarget: 'side'
  },
  defaultType : 'textfield',
  items       : [{
    name: 'nodeId',
    hidden: true,
    hideLabel: true
  },{
    fieldLabel: 'ID',
    name: 'id',
    helpText : "sangomaInterfaceCommonAttributesID",
    disabled: true
  },{
    fieldLabel: 'Name',
    name: 'displayName',
    helpText : "sangomaInterfaceCommonAttributesdisplayName"
  },{
    fieldLabel: 'Type',
    name: 'type',
    disabled: true
  },{
    fieldLabel: 'Model',
    name: 'model',
    disabled: true
  },{
    fieldLabel: 'Number of Interfaces',
    name: 'numInterfaces',
    disabled: true
  }],
  buttons     : [{
    text: 'Save',
    handler: saveBoard
  },{
    text: 'Cancel',
    handler: boardCancelFunc
  }]
});

var panelVirtualDigitalBoard = new Ext.Panel({
  id           : 'panelVirtualDigitalBoard',
  region       : 'center',
  layout       : 'accordion',
  border       : false,
  closable     : false,
  buttonAlign  : 'right'
});

panelVirtualDigitalBoard.add(frmVirtualDigitalBoard);

var frmVirtualDigitalInterface = new Ext.FormPanel({
  id          : 'frmVirtualDigitalInterface',
  title       : 'Virtual Interface Details',
  labelWidth  : 75, // label settings here cascade unless overridden
  frame       : true,
  bodyStyle   : 'padding:5px 5px 0',
  width       : 350,
  autoScroll  : true,
  labelPad    : 20,
  layout      : 'form',
  layoutConfig: {
    labelSeparator: ''
  },
  defaults    : {
    width: 230,
    msgTarget: 'side'
  },
  defaultType : 'textfield',

  items       : [{
    name: 'nodeId',
    hidden: true,
    hideLabel: true
  },{
    fieldLabel: 'ID',
    name: 'id',
    hidden: true,
    hideLabel: true
  },{
    fieldLabel: 'Name',
    name: 'displayName'
  },{
    fieldLabel: 'Peer Virtual Interface ID',
    name: 'peerVirtualInterfaceID',
    helpText: "sangomaVirtualDigitalInterfacesinterfacepeerVirtualInterfaceID",
    xtype: 'numberfield',
    allowNegative: false,
    allowDecimals: false
  }],

  buttons     : [{
    text: 'Save',
    handler: saveInterface
  },{
    text: 'Cancel',
    handler: boardCancelFunc
  }]
});
