Ext.BLANK_IMAGE_URL = '/toscawidgets/resources/tw.extjs/static/resources/images/default/s.gif';

// Option to offer virtual board passed by the widget
var offerVirtualBoards = $offerVirtualBoards;
Paraxip.console.debug('Virtual boards will be offered: ' + 
    offerVirtualBoards);

Ext.onReady(function() {
  Ext.namespace('Paraxip.mainTabPanel');
	Paraxip.mainTabPanel.isGatewayStarted = false;
	Paraxip.mainTabPanel.previousGWStatus = false; //Keep trace of the old status. Only for routing rules tab.

  Paraxip.mainTabPanel.changeStatusTabDisplay = function(activeTab) {
    if (Paraxip.mainTabPanel.isGatewayStarted) {
      activeTab.body.load({url: '/status', nocache: false});
    } else {
      activeTab.body.load({url: '/static/gateway_down.html', nocache: false});
    }
  };

  Paraxip.mainTabPanel.changeConfigTabDisplay = function(activeTab) {
    var routingTab = activeTab.findById("routingRulesTabId");

    if (Paraxip.mainTabPanel.isGatewayStarted) {
      routingTab.body.load({url: '/config/routing', nocache: false});
    } else {
      routingTab.body.load({url: '/static/gateway_down.html', nocache: false});
    }
  };

  Paraxip.mainTabPanel.start_btn = new Ext.Button({
		id: 'startGwButton',
    text: 'Start Gateway'
  });

  Paraxip.mainTabPanel.stop_btn = new Ext.Button({
		id: 'stopGwButton',
    text: 'Stop Gateway'
  });

  //status check call back function
  Paraxip.mainTabPanel.gwStatusBar = new Ext.StatusBar({
    id          : 'gw_status_bar',
    height      : 30,
    hideBorders : true,
		items				: [Paraxip.mainTabPanel.start_btn,'-',Paraxip.mainTabPanel.stop_btn]
  });

  //Create Status Bar
  Paraxip.mainTabPanel.tabPanel = new Ext.TabPanel({
    id                : 'mainTabPanel',
    width             : $width,
    height            : $height,
    renderTo          : "$renderTo",
    deferredRender    : false,
    frame             : $frame,
    layoutOnTabChange : false,
    autoScroll        : $autoScroll,
    bbar              : Paraxip.mainTabPanel.gwStatusBar
  });

  Paraxip.mainTabPanel.isGwStartedCall = function() {
    //Paraxip.changeGwStatusBar(Paraxip.workingStatus, true, true);
    Ext.Ajax.request({
      url: 'status/isGatewayStarted',
      method: 'POST',
      disableCaching: true,
      params: {js:Ext.util.JSON.encode('dummy param')},
      success: function (result)
      {
        var response = Ext.util.JSON.decode(result.responseText);
				//keep trace of the old status.
        Paraxip.mainTabPanel.isGatewayStarted = response.value;

				if (Paraxip.mainTabPanel.isGatewayStarted) {
          Paraxip.changeGwStatusBar(Paraxip.activeStatus, true, false);
        } else {
          Paraxip.changeGwStatusBar(Paraxip.downStatus, false, true);
        }

        var activeTab = Paraxip.mainTabPanel.tabPanel.getActiveTab();
        if (activeTab.id == "statusControlTabId") {
          Paraxip.mainTabPanel.changeStatusTabDisplay(activeTab);
        } else if (activeTab.id == "configTabId" && Paraxip.mainTabPanel.isGatewayStarted 
									 != Paraxip.mainTabPanel.previousGWStatus) {
					Paraxip.mainTabPanel.previousGWStatus = Paraxip.mainTabPanel.isGatewayStarted;
					//We change the panel content only if the status has been modified.
					Paraxip.mainTabPanel.changeConfigTabDisplay(activeTab);
        }
      },
      failure: Paraxip.failureMessage
    });
  };

  Paraxip.mainTabPanel.start_btn.on('click', function() {
    Paraxip.changeGwStatusBar(Paraxip.workingStatus, true, true);
		Paraxip.showProgressBar("Starting the gateway...")
    Ext.Ajax.request({
      url: 'status/startGatewayButton',
      disableCaching: true,
      params: {js:Ext.util.JSON.encode('dummy param')},
				success: function(result){
					Paraxip.hideProgressBar();
					var response = Ext.util.JSON.decode(result.responseText);
					if (!response.value) {
						Ext.Msg.alert("Unable to start the gateway","The gateway failed to start.\n\nPlease be sure there is a valid configuration file before launching the gateway. This can be accomplished by running the Quick Setup");
					}
					Paraxip.mainTabPanel.isGwStartedCall();
        },
				failure: function(){
					Paraxip.hideProgressBar();
					Paraxip.mainTabPanel.isGwStartedCall();
					Paraxip.failureMessage();				
				}
    });
  });

	function stopGwButtonMethod(answer) {
		if ( answer == "yes" ) {
			Paraxip.changeGwStatusBar(Paraxip.workingStatus, true, true);
			Paraxip.showProgressBar("Stopping the gateway...")
			Ext.Ajax.request({
				url: 'status/stopGatewayButton',
				disableCaching: true,
				params: {js:Ext.util.JSON.encode('dummy param')},
				success: function(result){
					Paraxip.hideProgressBar();
					var response = Ext.util.JSON.decode(result.responseText);
					if (!response.value) {
						Ext.Msg.alert("Unable to stop the gateway","Failed to stop the gateway. Gateway may already be stopped.");
					}
					Paraxip.mainTabPanel.isGwStartedCall();
				},
				failure: function(){
					Paraxip.hideProgressBar();
					Paraxip.mainTabPanel.isGwStartedCall();
					Paraxip.failureMessage();				
				}
			});
		}
  };
  Paraxip.mainTabPanel.stop_btn.on('click', function(){
		Ext.Msg.confirm("Stopping Gateway!","You are about to stop the gateway.Are you sure you want to proceed?", stopGwButtonMethod);
	});

  var items = $items;

  var itemIndex;

  for (itemIndex in items) {
    if (itemIndex < items.length) {
      items[itemIndex].layout = 'fit';
      Paraxip.mainTabPanel.tabPanel.add(items[itemIndex]);
    }
  }

  Paraxip.mainTabPanel.tabPanel.getItem("wizardTabId").add(wizard);
  Paraxip.mainTabPanel.tabPanel.getItem("configTabId").add(configTabPanel);
	Paraxip.mainTabPanel.tabPanel.doLayout();
	Paraxip.mainTabPanel.tabPanel.setActiveTab('$activeTab');
	Ext.Ajax.request({
		url: "/configFileExist",
		disableCaching: true,
		success: function (result, request)
		{
			var response = Ext.util.JSON.decode(result.responseText);
			if (!response.configFileExist) {
				Paraxip.mainTabPanel.tabPanel.setActiveTab('wizardTabId');
			} else {
				Paraxip.mainTabPanel.tabPanel.setActiveTab('statusControlTabId');
			}
		}
	});

  Paraxip.mainTabPanel.tabPanel.on('tabchange', function(tabPanel, newTab) {
		tabPanel.setActiveTab(newTab);
		Paraxip.mainTabPanel.isGwStartedCall();
		if( newTab.id == "configTabId") {
      if( newTab.layout.activeItem !== null && newTab.layout.activeItem.getId() == "pstnEditorTabId") {
        //Call the reloadTree(false) method from editor.js file
        reloadTree(false);
      }
    }
  });
  
  // This task manager tells the broser every minute to reload the
  // page if the selected tab is STATUS AND CONTROL and also to check
  // the status of the gateway to update the status bar.
  var task = {
    run: function() {
      Paraxip.mainTabPanel.isGwStartedCall();
    },
    interval: 60000 //1 minute
  };
  Ext.TaskMgr.start(task);

});

