//-----------------------------------------------
// Function used to disable/enable every button
// from a radiogroup.
//-----------------------------------------------
var disablingLoop = function(e, isVisible) {

  e.setVisible(isVisible);
  e.setDisabled(!isVisible);
};
//-----------------------------------------------
// Main form that contains all the fields
//-----------------------------------------------
var isdn_form = new Ext.Panel({
  title           : "PSTN Digital Configuration",
  layout      : 'form',
  frame           : true,
  standardSubmit  : true,
  header      : false,
  id              : "isdn_form",
  defaults : {
    autoHeight: true,
    autoWidth: true,
    layout: 'column'
  }  
});

var DigitDescriptionLabel = new Ext.form.Label({
  id:  "DigitDescriptionLabel",
  text: "Select the PSTN digital configuration",  
  style: 'font-size:120%;font-weight:bold; line-height:60px;text-align:left;' 
});


//-----------------------------------------------
// Interface Type fields
//-----------------------------------------------
var radio_t1 = new Ext.form.Radio({
  boxLabel    : 'T1',
  id          : 'Radio_T1',
  name        : 'interface_type',
  inputValue  : 'T1',
  checked     : true
});

var radio_e1 = new Ext.form.Radio({
  boxLabel    : 'E1',
  id          : 'Radio_E1',
  name        : 'interface_type',
  inputValue  : 'E1',
  width       : 235,
  listeners   : {
    'check':function() {
      var parent = this.findParentByType('panel');

      var framing_T1 = parent.findById('framingT1');

      var framing_E1 = parent.findById('framingE1');

      var encoding_T1 = parent.findById('encodingT1');

      var encoding_E1 = parent.findById('encodingE1');

      var isdn_sw_T1 = parent.findById('isdnSwT1');

      var isdn_sw_E1 = parent.findById('isdnSwE1');

      var nfas_t1 = parent.findById('nfas');

      var isT1Visible;
      var isE1Visible;

      if (this.getValue()) {
        isT1Visible = false;
        isE1Visible = true;
      } else {
        isT1Visible = true;
        isE1Visible = false;
      }

      //T1 interface's fields
      disablingLoop(framing_T1, isT1Visible);
      disablingLoop(encoding_T1, isT1Visible);
      disablingLoop(isdn_sw_T1, isT1Visible);
      //disablingLoop(nfas_t1, isT1Visible);

      //E1 interface's fields
      disablingLoop(framing_E1, isE1Visible);
      disablingLoop(encoding_E1, isE1Visible);
      disablingLoop(isdn_sw_E1, isE1Visible);

    }
  }

});

var interfaces = new Ext.form.FieldSet({
  id          : "interfaces",
  title       : "Interface Type"
});

interfaces.add(radio_t1);
interfaces.add(radio_e1);

//-----------------------------------------------
// Framing Type fields
//-----------------------------------------------
var esf = new Ext.form.Radio({boxLabel: 'ESF', name: 'framing_T1',inputValue: 'ESF', checked: 'true'});

var d4 = new Ext.form.Radio({boxLabel: 'D4', name: 'framing_T1',inputValue: 'D4', width: 223});

var esf_japan = new Ext.form.Radio({boxLabel: 'ESF Japan', name: 'framing_T1',inputValue: 'ESF_Japan', width: 104});

var crc4 = new Ext.form.Radio({boxLabel: 'CRC4', name: 'framing_E1',inputValue: 'CRC4', checked: 'true'});

var non_crc4 = new Ext.form.Radio({boxLabel: 'NON CRC4', name: 'framing_E1',inputValue: 'NonCRC4', width: 245});

var framing = new Ext.form.FieldSet({
  title       : "Framing Type",
  id          : "framingT1"
});

var framingE1 = new Ext.form.FieldSet({
  title       : "Framing Type",
  hidden      : true,
  id          : "framingE1"
});

framing.add(esf);
framingE1.add(crc4);
framing.add(d4);
framingE1.add(non_crc4);
framing.add(esf_japan);

//-----------------------------------------------
// Encoding Type fields
//-----------------------------------------------
var b8zs = new Ext.form.Radio({boxLabel: 'B8ZS', name: 'encoding_T1',inputValue: 'B8ZS', checked: 'true'});

var ami_t1 = new Ext.form.Radio({boxLabel: 'AMI', name: 'encoding_T1',inputValue: 'AMI', width: 218});

var hdb3 = new Ext.form.Radio({boxLabel: 'HDB3', name: 'encoding_E1',inputValue: 'HDB3', checked: 'true'});

var ami_e1 = new Ext.form.Radio({boxLabel: 'AMI', name: 'encoding_E1',inputValue: 'AMI', width: 213});

var encoding = new Ext.form.FieldSet({
  title       : "Encoding Type",
  id          : "encodingT1"
});

var encodingE1 = new Ext.form.FieldSet({
  title       : "Encoding Type",
  id          : "encodingE1",
  hidden      : true
});

encoding.add(b8zs);
encodingE1.add(hdb3);
encoding.add(ami_t1);
encodingE1.add(ami_e1);

//-----------------------------------------------
// ISDN Switch variant fields
//-----------------------------------------------
var lucent = new Ext.form.Radio({boxLabel: 'Lucent 5ESS', name: 'isdn_sw_T1',inputValue: '5ESS', checked: 'true'});

var etsi = new Ext.form.Radio({boxLabel: 'EuroISDN (ETSI, NET5)', name: 'isdn_sw_E1',inputValue: 'ETSI', checked: 'true'});

var nortel = new Ext.form.Radio({boxLabel: 'Nortel DMS100', name: 'isdn_sw_T1', inputValue: 'DMS100', width: 200});

var ni2 = new Ext.form.Radio({boxLabel: 'National ISDN 2 (NI2)', name: 'isdn_sw_T1', inputValue: 'NI2'});

var isdn_sw = new Ext.form.FieldSet({
  title       : "ISDN Switch Variant",
  id          : "isdnSwT1"
});

var isdnSwE1 = new Ext.form.FieldSet({
  title       : "ISDN Switch Variant",
  id          : "isdnSwE1",
  hidden      : true
});

isdn_sw.add(lucent);
isdnSwE1.add(etsi);
isdn_sw.add(nortel);
isdn_sw.add(ni2);

//-----------------------------------------------
// NFAS checkbox fields
//-----------------------------------------------
//var nfasCB = new Ext.form.Checkbox({
//  id          : "nfasCB",
//  boxLabel    : "Create a single NFAS Group"
//});
//
//var nfasFs = new Ext.form.FieldSet({
//  id          : "nfas",
//  title       : "NFAS Group"
//});
//
//nfasFs.add(nfasCB);
isdn_form.add(DigitDescriptionLabel);
isdn_form.add(interfaces);
isdn_form.add(framing);
isdn_form.add(framingE1);
isdn_form.add(encoding);
isdn_form.add(encodingE1);
isdn_form.add(isdn_sw);
isdn_form.add(isdnSwE1);
//isdn_form.add(nfasFs);


